# -*- coding: utf-8 -*-
from setuphelpers import *
import configparser

repos_to_remove = []


def install():
    if not isdir(get_public_persistent_dir()):
        mkdirs(get_public_persistent_dir())
    filecopyto(r"WAPT\public_persistent\waptconsole.ini", get_public_persistent_dir())


def uninstall():
    if isfile(get_public_persistent_file("waptconsole.ini")):
        remove_file(get_public_persistent_file("waptconsole.ini"))


def session_setup():
    user_local_waptconsole_ini = makepath(user_local_appdata, "waptconsole", "waptconsole.ini")
    new_local_waptconsole_ini = get_public_persistent_file("waptconsole.ini")

    new_inifile = configparser.RawConfigParser()
    new_inifile.read(new_local_waptconsole_ini)

    user_inifile = configparser.RawConfigParser()
    user_inifile.read(user_local_waptconsole_ini)

    # Comparing ini files
    sections_updated = False
    for section in new_inifile.sections():
        if section not in ["global", "waptwua"] and section not in user_inifile.sections():
            print(f"[{section}] added")
            sections_updated = True
            if not user_inifile.has_section(section):
                user_inifile.add_section(section)
            user_inifile.set(section, "repo_url", new_inifile[section]["repo_url"])
    for section in user_inifile.sections():
        if section in repos_to_remove:
            print(f"[{section}] removed")
            sections_updated = True
            user_inifile.remove_section(section)
    if sections_updated:
        print("WAPT repos updated in WAPT Console")
        user_inifile.write(open(user_local_waptconsole_ini, "w"))


def get_public_persistent_dir():
    return makepath(WAPT.wapt_base_dir, "public", "persistent")


def get_public_persistent_file(fname):
    return makepath(WAPT.wapt_base_dir, "public", "persistent", fname)
